import { BaseSopOperation } from './_Base';
import { DefaultOperationParams } from '../_Base';
import { CoreGroup } from '../../geometry/Group';
import { InputCloneMode } from '../../../engine/poly/InputCloneMode';
interface TexturePropertiesSopParams extends DefaultOperationParams {
    applyToChildren: boolean;
    tanisotropy: boolean;
    useRendererMaxAnisotropy: boolean;
    anisotropy: number;
    tminFilter: boolean;
    minFilter: number;
    tmagFilter: boolean;
    magFilter: number;
}
export declare class TexturePropertiesSopOperation extends BaseSopOperation {
    static readonly DEFAULT_PARAMS: TexturePropertiesSopParams;
    static readonly INPUT_CLONED_STATE = InputCloneMode.FROM_NODE;
    static type(): Readonly<'textureProperties'>;
    cook(input_contents: CoreGroup[], params: TexturePropertiesSopParams): Promise<CoreGroup>;
    private _update_object;
    private _update_material;
    private _update_texture;
    private _update_anisotropy;
    private _update_filter;
}
export {};
