import { BaseNodeType } from '../../engine/nodes/_Base';
export interface PerformancePrintObject {
    fullPath: string;
    cooks_count: number;
    total_time: number;
    total_cook_time: number;
    cook_time_per_iteration: number;
    inputs_time_per_iteration: number;
    params_time_per_iteration: number;
}
import { NodePerformanceData } from '../../engine/nodes/utils/cook/PerformanceController';
export declare class PerformanceNode {
    private _node;
    _cooks_count: number;
    _total_cook_time: number;
    _total_inputs_time: number;
    _total_params_time: number;
    constructor(_node: BaseNodeType);
    update_cook_data(performance_data: NodePerformanceData): void;
    total_time(): number;
    total_cook_time(): number;
    cook_time_per_iteration(): number;
    total_inputs_time(): number;
    inputs_time_per_iteration(): number;
    total_params_time2(): number;
    params_time_per_iteration2(): number;
    cooks_count(): number;
    print_object(): PerformancePrintObject;
}
