import { Vector3 } from 'three/src/math/Vector3';
import { Box3 } from 'three/src/math/Box3';
import { TypedContainer } from './_Base';
import { CoreGroup } from '../../core/geometry/Group';
import { ContainableMap } from './utils/ContainableMap';
import { AttribType, ObjectData } from '../../core/geometry/Constant';
import { NodeContext } from '../poly/NodeContext';
import { PolyDictionary } from '../../types/GlobalTypes';
export declare class GeometryContainer extends TypedContainer<NodeContext.SOP> {
    coreContentCloned(): CoreGroup | undefined;
    set_content(content: ContainableMap[NodeContext.SOP]): void;
    private firstObject;
    private firstCoreObject;
    private firstGeometry;
    objectsCount(): number;
    objectsVisibleCount(): number;
    objectsCountByType(): PolyDictionary<number>;
    objectsNamesByType(): PolyDictionary<string[]>;
    pointAttributeNames(): string[];
    pointAttributeSizesByName(): PolyDictionary<number>;
    objectAttributeSizesByName(): PolyDictionary<number>;
    pointAttributeTypesByName(): PolyDictionary<AttribType>;
    objectAttributeTypesByName(): PolyDictionary<AttribType>;
    objectAttributeNames(): string[];
    pointsCount(): number;
    totalPointsCount(): number;
    objectsData(): ObjectData[];
    boundingBox(): Box3;
    center(): Vector3;
    size(): Vector3;
}
