import { Number2, Boolean2 } from '../../../../types/GlobalTypes';
import { PolyScene } from '../../../scene/PolyScene';
import { NodeJsonExporterData, NodeJsonExporterUIData } from './Node';
export interface SceneJsonExporterDataProperties {
    frame: number;
    frameRange: Number2;
    frameRangeLocked: Boolean2;
    realtimeState: boolean;
    masterCameraNodePath: string | null;
}
export interface SceneJsonExporterData {
    properties?: SceneJsonExporterDataProperties;
    root?: NodeJsonExporterData;
    ui?: NodeJsonExporterUIData;
}
export declare class SceneJsonExporter {
    private _scene;
    private _data;
    constructor(_scene: PolyScene);
    data(): SceneJsonExporterData;
    static sanitize_string(word: string): string;
}
