import { PolyDictionary } from '../../../../types/GlobalTypes';
import { NodeJsonExporterData, NodeJsonExporterUIData } from '../../json/export/Node';
import { SceneJsonExporterData, SceneJsonExporterDataProperties } from '../../json/export/Scene';
export declare type ManifestNodesData = PolyDictionary<string>;
export interface ManifestContent {
    properties: string;
    root: string;
    nodes: ManifestNodesData;
}
interface ImportData {
    urlPrefix: string;
    manifest: ManifestContent;
    editorMode?: boolean;
}
export interface SceneDataElements {
    root: NodeJsonExporterData;
    properties: SceneJsonExporterDataProperties;
    ui?: NodeJsonExporterUIData;
}
export declare class SceneDataManifestImporter {
    static importSceneData(import_data: ImportData): Promise<SceneJsonExporterData>;
    static assemble(assemble_data: SceneDataElements, manifest_nodes: string[], json_by_name: PolyDictionary<object>): Promise<SceneJsonExporterData>;
    private static insert_child_data;
}
export {};
