/**
 * Creates a THREE DevideOrientationControls
 *
 * @remarks
 * This can be linked to a camera's controls parameter
 *
 */
import { Camera } from 'three/src/cameras/Camera';
import { TypedCameraControlsEventNode, CameraControls } from './_BaseCameraControls';
import { DeviceOrientationControls } from '../../../modules/three/examples/jsm/controls/DeviceOrientationControls';
import { CameraControlsNodeType } from '../../poly/NodeContext';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class CameraDeviceOrientationControlsEventParamsConfig extends NodeParamsConfig {
    /** @param enable/disable */
    enabled: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
}
export declare class CameraDeviceOrientationControlsEventNode extends TypedCameraControlsEventNode<CameraDeviceOrientationControlsEventParamsConfig> {
    params_config: CameraDeviceOrientationControlsEventParamsConfig;
    static type(): CameraControlsNodeType;
    private _controls_by_element_id;
    create_controls_instance(camera: Camera, element: HTMLElement): Promise<DeviceOrientationControls>;
    setup_controls(controls: CameraControls): void;
    update_required(): boolean;
    dispose_controls_for_html_element_id(html_element_id: string): void;
}
export {};
