import { TypedInputEventNode } from './_BaseInput';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class SceneEventParamsConfig extends NodeParamsConfig {
    /** @param toggle on to allow any event to be listened to */
    active: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    sep: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.SEPARATOR>;
    /** @param toggle on to trigger an event when the scene has loaded. This can be useful to initialize other nodes */
    sceneLoaded: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to trigger an event when the scene starts playing */
    play: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to trigger an event when the scene pauses */
    pause: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to trigger an event on every tick */
    tick: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    sep0: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.SEPARATOR>;
    /** @param toggle on to trigger an event on every tick */
    treachedTime: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param time to trigger an event */
    reachedTime: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    sep1: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.SEPARATOR>;
    /** @param frame to set */
    setFrameValue: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    /** @param button to set a specific frame */
    setFrame: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BUTTON>;
}
export declare class SceneEventNode extends TypedInputEventNode<SceneEventParamsConfig> {
    params_config: SceneEventParamsConfig;
    static type(): string;
    private graph_node;
    protected accepted_event_types(): string[];
    dispose(): void;
    initializeNode(): void;
    private onSetFrame;
    private on_frame_update;
    private update_time_dependency;
    static PARAM_CALLBACK_setFrame(node: SceneEventNode): void;
    static PARAM_CALLBACK_update_time_dependency(node: SceneEventNode): void;
}
export {};
