/**
 * Activates events for the viewer
 *
 * @param
 * For instance, this can be useful after a raycast node to set an 'active' class on the html canvas, so that the cursor reflect what the mouse is hovering over.
 *
 */
import { TypedEventNode } from './_Base';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class ViewerParamsConfig extends NodeParamsConfig {
    /** @param sets the class of the viewer */
    className: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.STRING>;
}
export declare class ViewerEventNode extends TypedEventNode<ViewerParamsConfig> {
    params_config: ViewerParamsConfig;
    static type(): string;
    initializeNode(): void;
    private _process_trigger_setClass;
    private _process_trigger_unsetClass;
    private _process_trigger_createControls;
    private _process_trigger_disposeControls;
}
export {};
