/**
 * Creates a LineBasicMaterial, used to render lines
 *
 *
 */
import { LineBasicMaterial } from 'three/src/materials/LineBasicMaterial';
import { TypedMatNode } from './_Base';
import { DepthController } from './utils/DepthController';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare const LineBasicMatParamsConfig_base: {
    new (...args: any[]): {
        depthWrite: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
        depthTest: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    };
} & typeof NodeParamsConfig;
declare class LineBasicMatParamsConfig extends LineBasicMatParamsConfig_base {
    /** @param line color */
    color: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.COLOR>;
    /** @param line width */
    lineWidth: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
}
export declare class LineBasicMatNode extends TypedMatNode<LineBasicMaterial, LineBasicMatParamsConfig> {
    params_config: LineBasicMatParamsConfig;
    static type(): string;
    create_material(): LineBasicMaterial;
    readonly depth_controller: DepthController;
    initializeNode(): void;
    cook(): Promise<void>;
}
export {};
