/**
 * Creates an ambient light.
 *
 * @remarks
 * An ambient light will add a uniform light to every object. This can be useful to elevate the shadows slightly.
 *
 */
import { AmbientLight } from 'three/src/lights/AmbientLight';
import { TypedLightObjNode } from './_BaseLight';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class AmbientLightObjParamsConfig extends NodeParamsConfig {
    /** @param light color */
    color: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.COLOR>;
    /** @param light intensity */
    intensity: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
}
export declare class AmbientLightObjNode extends TypedLightObjNode<AmbientLight, AmbientLightObjParamsConfig> {
    params_config: AmbientLightObjParamsConfig;
    static type(): string;
    create_light(): AmbientLight;
    initializeNode(): void;
    update_light_params(): void;
}
export {};
