/**
 * Creates a CSS2DRenderer
 *
 * @param
 * If you want to display HTML elements that follow the 3D objects, you will need to create this node, and set the camera css renderer to it. If you can CSSObjects in your scene, they will then be displayed.
 *
 */
import { TypedRopNode } from './_Base';
import { CSS2DRenderer } from '../../../modules/core/renderers/CSS2DRenderer';
import { RopType } from '../../poly/registers/nodes/Rop';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class Css2DRendererRopParamsConfig extends NodeParamsConfig {
    /** @param css rules to be added in the html document */
    css: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.STRING>;
    /** @param toggle on to ensure objects z-index is set based on camera depth */
    sortObjects: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to have css opacity be set from camera depth */
    useFog: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param fog near */
    fogNear: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
    /** @param fog far */
    fogFar: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
}
export declare class Css2DRendererRopNode extends TypedRopNode<Css2DRendererRopParamsConfig> {
    params_config: Css2DRendererRopParamsConfig;
    static type(): Readonly<RopType.CSS2D>;
    private _renderers_by_canvas_id;
    create_renderer(canvas: HTMLCanvasElement): CSS2DRenderer;
    renderer(canvas: HTMLCanvasElement): CSS2DRenderer;
    cook(): void;
    private _update_renderer;
    private _update_css;
    private _css_element;
    private css_element;
    private _find_element;
    private _create_element;
    private _css_element_id;
}
export {};
