/**
 * A subnet to create EVENT nodes
 *
 */
import { ParamLessBaseNetworkRopNode } from './_BaseManager';
import { NodeContext, NetworkNodeType } from '../../poly/NodeContext';
import { EventNodeChildrenMap } from '../../poly/registers/nodes/Event';
import { BaseEventNodeType } from '../event/_Base';
import { ParamsInitData } from '../utils/io/IOController';
import { Constructor, valueof } from '../../../types/GlobalTypes';
export declare class EventsRopNode extends ParamLessBaseNetworkRopNode {
    static type(): NetworkNodeType;
    protected _children_controller_context: NodeContext;
    createNode<S extends keyof EventNodeChildrenMap>(node_class: S, params_init_value_overrides?: ParamsInitData): EventNodeChildrenMap[S];
    createNode<K extends valueof<EventNodeChildrenMap>>(node_class: Constructor<K>, params_init_value_overrides?: ParamsInitData): K;
    children(): BaseEventNodeType[];
    nodesByType<K extends keyof EventNodeChildrenMap>(type: K): EventNodeChildrenMap[K][];
}
