/**
 * Simple delay
 *
 * @remarks
 * This node outputs the exact same geometry as its input, but does so with a delay. This can be useful when some operations are not meant to run immediately.
 *
 */
import { TypedSopNode } from './_Base';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
import { CoreGroup } from '../../../core/geometry/Group';
declare class DelaySopParamsConfig extends NodeParamsConfig {
    /** @param duration in milliseconds */
    duration: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
}
export declare class DelaySopNode extends TypedSopNode<DelaySopParamsConfig> {
    params_config: DelaySopParamsConfig;
    static type(): string;
    initializeNode(): void;
    cook(inputs_contents: CoreGroup[]): void;
}
export {};
