/**
 * Creates an Isocahedron
 *
 * @remarks
 * This is similar to a sphere, but with hexagonal patterns
 */
import { TypedSopNode } from './_Base';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class IcosahedronSopParamsConfig extends NodeParamsConfig {
    /** @param radius of the icosahedron */
    radius: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
    /** @param resolution of the icosahedron */
    detail: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    /** @param do not create polygons, only points. */
    pointsOnly: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param center of the icosahedron */
    center: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.VECTOR3>;
}
export declare class IcosahedronSopNode extends TypedSopNode<IcosahedronSopParamsConfig> {
    params_config: IcosahedronSopParamsConfig;
    static type(): string;
    private _operation;
    cook(): void;
}
export {};
