/**
 * Moves points alongside the normal.
 *
 * @remarks
 * This can be useful to inflate or deflate quickly some objects.
 *
 *
 */
import { TypedSopNode } from './_Base';
import { CoreGroup } from '../../../core/geometry/Group';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class PeakSopParamsConfig extends NodeParamsConfig {
    /** @param amount the points will be moved */
    amount: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
}
export declare class PeakSopNode extends TypedSopNode<PeakSopParamsConfig> {
    params_config: PeakSopParamsConfig;
    static type(): string;
    initializeNode(): void;
    private _operation;
    cook(input_contents: CoreGroup[]): void;
}
export {};
