/**
 * Loads an svg file from a url.
 *
 *
 */
import { TypedSopNode } from './_Base';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
import { CoreGroup } from '../../../core/geometry/Group';
import { ModuleName } from '../../poly/registers/modules/_BaseRegister';
declare class SvgSopParamsConfig extends NodeParamsConfig {
    /** @param url to load the geometry from */
    url: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.STRING>;
    /** @param reload the geometry */
    reload: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BUTTON>;
    /** @param toggle on to draw the fillShapes */
    drawFillShapes: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to draw the fillShapes as wireframe */
    fillShapesWireframe: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to draw the strokes */
    drawStrokes: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
    /** @param toggle on to draw the strokes as wireframe */
    strokesWireframe: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.BOOLEAN>;
}
export declare class SvgSopNode extends TypedSopNode<SvgSopParamsConfig> {
    params_config: SvgSopParamsConfig;
    static type(): string;
    requiredModules(): Promise<ModuleName[]>;
    initializeNode(): void;
    private _operation;
    cook(input_contents: CoreGroup[]): Promise<void>;
    static PARAM_CALLBACK_reload(node: SvgSopNode): void;
    private param_callback_reload;
}
export {};
