/**
 * Creates text
 *
 *
 *
 */
import { TypedSopNode } from './_Base';
import { ModuleName } from '../../poly/registers/modules/_BaseRegister';
export declare enum TEXT_TYPE {
    MESH = "mesh",
    FLAT = "flat",
    LINE = "line",
    STROKE = "stroke"
}
export declare const TEXT_TYPES: Array<TEXT_TYPE>;
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class TextSopParamsConfig extends NodeParamsConfig {
    /** @param font used */
    font: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.STRING>;
    /** @param text created */
    text: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.STRING>;
    /** @param type of geometry created */
    type: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    /** @param font size */
    size: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
    /** @param extrude depth */
    extrude: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
    /** @param segments count */
    segments: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    /** @param stroke width */
    strokeWidth: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
}
export declare class TextSopNode extends TypedSopNode<TextSopParamsConfig> {
    params_config: TextSopParamsConfig;
    static type(): string;
    private _font_loader;
    private _loaded_fonts;
    initializeNode(): void;
    cook(): Promise<void>;
    private _create_geometry_from_type_mesh;
    private _create_geometry_from_type_flat;
    private _create_geometry_from_type_line;
    private _create_geometry_from_type_stroke;
    private shapes_from_font;
    private _get_shapes;
    private displayed_text;
    private _load_url;
    requiredModules(): Promise<ModuleName[] | undefined>;
    private get_extension;
    private _load_ttf;
    private _load_json;
    private _load_ttf_loader;
    private _load_svg_loader;
}
export {};
