/**
 * Creates a torus.
 *
 *
 */
import { TypedSopNode } from './_Base';
import { CoreGroup } from '../../../core/geometry/Group';
import { NodeParamsConfig } from '../utils/params/ParamsConfig';
declare class TorusSopParamsConfig extends NodeParamsConfig {
    /** @param large radius */
    radius: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
    /** @param radius of the tube */
    radiusTube: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.FLOAT>;
    /** @param number of segments along the length of the torus */
    segmentsRadial: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    /** @param number of segments along the tube */
    segmentsTube: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.INTEGER>;
    /** @param axis perpendicular to the torus */
    direction: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.VECTOR3>;
    /** @param center of the torus */
    center: import("../utils/params/ParamsConfig").ParamTemplate<import("../../poly/ParamType").ParamType.VECTOR3>;
}
export declare class TorusSopNode extends TypedSopNode<TorusSopParamsConfig> {
    params_config: TorusSopParamsConfig;
    static type(): string;
    private _operation;
    cook(input_contents: CoreGroup[]): void;
}
export {};
