import { Vector2 } from 'three/src/math/Vector2';
import { Color } from 'three/src/math/Color';
import { BaseNodeType } from '../_Base';
export interface NodeUIDataJson {
    x: number;
    y: number;
    comment?: string;
}
export declare class UIData {
    private node;
    private _position;
    protected _width: number;
    private _color;
    private _layout_vertical;
    private _comment;
    private _json;
    constructor(node: BaseNodeType, x?: number, y?: number);
    width(): number;
    setComment(comment: string | undefined): void;
    comment(): string | undefined;
    setColor(color: Color): void;
    color(): Color;
    setLayoutHorizontal(): void;
    isLayoutVertical(): boolean;
    copy(ui_data: UIData): void;
    position(): Vector2;
    setPosition(new_position: Vector2 | number, y?: number): void;
    translate(offset: Vector2, snap?: boolean): void;
    toJSON(): NodeUIDataJson;
}
