import { FloatToIntGlNode } from '../../../nodes/gl/_ConversionMisc';
import { FloatToVec2GlNode, FloatToVec3GlNode, FloatToVec4GlNode } from '../../../nodes/gl/_ConversionToVec';
import { Vec2ToFloatGlNode, Vec3ToFloatGlNode, Vec4ToFloatGlNode, Vec4ToVec3GlNode, Vec3ToVec4GlNode, Vec3ToVec2GlNode, Vec2ToVec3GlNode } from '../../../nodes/gl/_ConversionVecTo';
import { AbsGlNode, AcosGlNode, AsinGlNode, AtanGlNode, CeilGlNode, CosGlNode, DegreesGlNode, ExpGlNode, Exp2GlNode, FloorGlNode, FractGlNode, InverseSqrtGlNode, LogGlNode, Log2GlNode, NormalizeGlNode, RadiansGlNode, SignGlNode, SinGlNode, SqrtGlNode, TanGlNode } from '../../../nodes/gl/_Math_Arg1';
import { DistanceGlNode, DotGlNode, MaxGlNode, MinGlNode, ModGlNode, PowGlNode, ReflectGlNode, StepGlNode } from '../../../nodes/gl/_Math_Arg2';
import { ClampGlNode, FaceforwardGlNode, SmoothstepGlNode } from '../../../nodes/gl/_Math_Arg3';
import { AddGlNode, DivideGlNode, MultGlNode, SubstractGlNode } from '../../../nodes/gl/_Math_Arg2Operation';
import { AndGlNode, OrGlNode } from '../../../nodes/gl/_Math_Arg2Boolean';
import { AccelerationGlNode } from '../../../nodes/gl/Acceleration';
import { AlignGlNode } from '../../../nodes/gl/Align';
import { AttributeGlNode } from '../../../nodes/gl/Attribute';
import { ColorCorrectGlNode } from '../../../nodes/gl/ColorCorrect';
import { CompareGlNode } from '../../../nodes/gl/Compare';
import { ComplementGlNode } from '../../../nodes/gl/Complement';
import { ConstantGlNode } from '../../../nodes/gl/Constant';
import { CrossGlNode } from '../../../nodes/gl/Cross';
import { CycleGlNode } from '../../../nodes/gl/Cycle';
import { DiskGlNode } from '../../../nodes/gl/Disk';
import { EasingGlNode } from '../../../nodes/gl/Easing';
import { FitGlNode, FitTo01GlNode, FitFrom01GlNode, FitFrom01ToVarianceGlNode } from '../../../nodes/gl/Fit';
import { FogGlNode } from '../../../nodes/gl/Fog';
import { ForLoopGlNode } from '../../../nodes/gl/ForLoop';
import { GlobalsGlNode } from '../../../nodes/gl/Globals';
import { HsluvToRgbGlNode } from '../../../nodes/gl/HsluvToRgb';
import { HsvToRgbGlNode } from '../../../nodes/gl/HsvToRgb';
import { IfThenGlNode } from '../../../nodes/gl/IfThen';
import { ImpostorUvGlNode } from '../../../nodes/gl/ImpostorUv';
import { InstanceTransformGlNode } from '../../../nodes/gl/InstanceTransform';
import { LengthGlNode } from '../../../nodes/gl/Length';
import { LuminanceGlNode } from '../../../nodes/gl/Luminance';
import { MaxLengthGlNode } from '../../../nodes/gl/MaxLength';
import { MixGlNode } from '../../../nodes/gl/Mix';
import { ModelViewMatrixMultGlNode } from '../../../nodes/gl/ModelViewMatrixMult';
import { MultAddGlNode } from '../../../nodes/gl/MultAdd';
import { NegateGlNode } from '../../../nodes/gl/Negate';
import { NoiseGlNode } from '../../../nodes/gl/Noise';
import { NullGlNode } from '../../../nodes/gl/Null';
import { OutputGlNode } from '../../../nodes/gl/Output';
import { ParamGlNode } from '../../../nodes/gl/Param';
import { RefractGlNode } from '../../../nodes/gl/Refract';
import { QuatMultGlNode } from '../../../nodes/gl/QuatMult';
import { QuatFromAxisAngleGlNode } from '../../../nodes/gl/QuatFromAxisAngle';
import { QuatToAngleGlNode } from '../../../nodes/gl/QuatToAngle';
import { QuatToAxisGlNode } from '../../../nodes/gl/QuatToAxis';
import { RampGlNode } from '../../../nodes/gl/Ramp';
import { RandomGlNode } from '../../../nodes/gl/Random';
import { RgbToHsvGlNode } from '../../../nodes/gl/RgbToHsv';
import { RotateGlNode } from '../../../nodes/gl/Rotate';
import { RoundGlNode } from '../../../nodes/gl/Round';
import { SphereGlNode } from '../../../nodes/gl/Sphere';
import { SubnetGlNode } from '../../../nodes/gl/Subnet';
import { SubnetInputGlNode } from '../../../nodes/gl/SubnetInput';
import { SubnetOutputGlNode } from '../../../nodes/gl/SubnetOutput';
import { SwitchGlNode } from '../../../nodes/gl/Switch';
import { TextureGlNode } from '../../../nodes/gl/Texture';
import { TwoWaySwitchGlNode } from '../../../nodes/gl/TwoWaySwitch';
import { VaryingWriteGlNode } from '../../../nodes/gl/VaryingWrite';
import { VaryingReadGlNode } from '../../../nodes/gl/VaryingRead';
import { VectorAlignGlNode } from '../../../nodes/gl/VectorAlign';
import { VectorAngleGlNode } from '../../../nodes/gl/VectorAngle';
export interface GlNodeChildrenMap {
    abs: AbsGlNode;
    acceleration: AccelerationGlNode;
    acos: AcosGlNode;
    add: AddGlNode;
    align: AlignGlNode;
    and: AndGlNode;
    asin: AsinGlNode;
    atan: AtanGlNode;
    attribute: AttributeGlNode;
    ceil: CeilGlNode;
    clamp: ClampGlNode;
    colorCorrect: ColorCorrectGlNode;
    compare: CompareGlNode;
    complement: ComplementGlNode;
    constant: ConstantGlNode;
    cos: CosGlNode;
    cross: CrossGlNode;
    cycle: CycleGlNode;
    degrees: DegreesGlNode;
    disk: DiskGlNode;
    distance: DistanceGlNode;
    divide: DivideGlNode;
    dot: DotGlNode;
    easing: EasingGlNode;
    exp: ExpGlNode;
    exp2: Exp2GlNode;
    faceForward: FaceforwardGlNode;
    fit: FitGlNode;
    fitTo01: FitTo01GlNode;
    fitFrom01: FitFrom01GlNode;
    fitFrom01ToVariance: FitFrom01ToVarianceGlNode;
    floatToInt: FloatToIntGlNode;
    floatToVec2: FloatToVec2GlNode;
    floatToVec3: FloatToVec3GlNode;
    floatToVec4: FloatToVec4GlNode;
    floor: FloorGlNode;
    fract: FractGlNode;
    fog: FogGlNode;
    forLoop: ForLoopGlNode;
    globals: GlobalsGlNode;
    hsluvToRgb: HsluvToRgbGlNode;
    hsvToRgb: HsvToRgbGlNode;
    ifThen: IfThenGlNode;
    impostorUv: ImpostorUvGlNode;
    intToFloat: FloatToIntGlNode;
    inverseSqrt: InverseSqrtGlNode;
    instanceTransform: InstanceTransformGlNode;
    length: LengthGlNode;
    log: LogGlNode;
    log2: Log2GlNode;
    luminance: LuminanceGlNode;
    max: MaxGlNode;
    maxLength: MaxLengthGlNode;
    min: MinGlNode;
    mix: MixGlNode;
    mod: ModGlNode;
    modelViewMatrixMult: ModelViewMatrixMultGlNode;
    mult: MultGlNode;
    multAdd: MultAddGlNode;
    negate: NegateGlNode;
    noise: NoiseGlNode;
    normalize: NormalizeGlNode;
    null: NullGlNode;
    or: OrGlNode;
    output: OutputGlNode;
    param: ParamGlNode;
    pow: PowGlNode;
    quatMult: QuatMultGlNode;
    quatFromAxisAngle: QuatFromAxisAngleGlNode;
    quatToAngle: QuatToAngleGlNode;
    quatToAxis: QuatToAxisGlNode;
    radians: RadiansGlNode;
    ramp: RampGlNode;
    random: RandomGlNode;
    reflect: ReflectGlNode;
    refract: RefractGlNode;
    rgbToHsv: RgbToHsvGlNode;
    rotate: RotateGlNode;
    round: RoundGlNode;
    sign: SignGlNode;
    sin: SinGlNode;
    smoothstep: SmoothstepGlNode;
    sphere: SphereGlNode;
    sqrt: SqrtGlNode;
    step: StepGlNode;
    subnet: SubnetGlNode;
    subnetInput: SubnetInputGlNode;
    subnetOutput: SubnetOutputGlNode;
    substract: SubstractGlNode;
    switch: SwitchGlNode;
    tan: TanGlNode;
    texture: TextureGlNode;
    twoWaySwitch: TwoWaySwitchGlNode;
    varyingWrite: VaryingWriteGlNode;
    varyingRead: VaryingReadGlNode;
    vec2ToFloat: Vec2ToFloatGlNode;
    vec2ToVec3: Vec2ToVec3GlNode;
    vec3ToFloat: Vec3ToFloatGlNode;
    vec3ToVec2: Vec3ToVec2GlNode;
    vec3ToVec4: Vec3ToVec4GlNode;
    vec4ToFloat: Vec4ToFloatGlNode;
    vec4ToVec3: Vec4ToVec3GlNode;
    vectorAlign: VectorAlignGlNode;
    vectorAngle: VectorAngleGlNode;
}
import { PolyEngine } from '../../../Poly';
export declare class GlRegister {
    static run(poly: PolyEngine): void;
}
