import { AnimationsRopNode } from '../../../nodes/rop/Animations';
import { CopRopNode } from '../../../nodes/rop/Cop';
import { Css2DRendererRopNode } from '../../../nodes/rop/Css2DRenderer';
import { Css3DRendererRopNode } from '../../../nodes/rop/Css3DRenderer';
import { EventsRopNode } from '../../../nodes/rop/Events';
import { MaterialsRopNode } from '../../../nodes/rop/Materials';
import { PostProcessRopNode } from '../../../nodes/rop/PostProcess';
import { RenderersRopNode } from '../../../nodes/rop/Renderers';
import { WebGlRendererRopNode } from '../../../nodes/rop/WebGlRenderer';
export declare enum RopType {
    CSS2D = "css2DRenderer",
    CSS3D = "css3DRenderer",
    WEBGL = "webGlRenderer"
}
export interface RopNodeChildrenMap {
    css2DRenderer: Css2DRendererRopNode;
    css3DRenderer: Css3DRendererRopNode;
    webGlRenderer: WebGlRendererRopNode;
    animations: AnimationsRopNode;
    cop: CopRopNode;
    events: EventsRopNode;
    materials: MaterialsRopNode;
    postProcess: PostProcessRopNode;
    renderers: RenderersRopNode;
}
import { PolyEngine } from '../../../Poly';
export declare class RopRegister {
    static run(poly: PolyEngine): void;
}
