import {CATEGORY_ROP} from "./Category";
import {AnimationsRopNode} from "../../../nodes/rop/Animations";
import {CopRopNode} from "../../../nodes/rop/Cop";
import {Css2DRendererRopNode} from "../../../nodes/rop/Css2DRenderer";
import {EventsRopNode} from "../../../nodes/rop/Events";
import {MaterialsRopNode} from "../../../nodes/rop/Materials";
import {PostProcessRopNode} from "../../../nodes/rop/PostProcess";
import {RenderersRopNode} from "../../../nodes/rop/Renderers";
import {WebGlRendererRopNode} from "../../../nodes/rop/WebGlRenderer";
export var RopType;
(function(RopType2) {
  RopType2["CSS2D"] = "css2DRenderer";
  RopType2["CSS3D"] = "css3DRenderer";
  RopType2["WEBGL"] = "webGlRenderer";
})(RopType || (RopType = {}));
export class RopRegister {
  static run(poly) {
    poly.registerNode(Css2DRendererRopNode, CATEGORY_ROP.CSS);
    poly.registerNode(WebGlRendererRopNode, CATEGORY_ROP.WEBGL);
    poly.registerNode(AnimationsRopNode, CATEGORY_ROP.NETWORK);
    poly.registerNode(CopRopNode, CATEGORY_ROP.NETWORK);
    poly.registerNode(EventsRopNode, CATEGORY_ROP.NETWORK);
    poly.registerNode(MaterialsRopNode, CATEGORY_ROP.NETWORK);
    poly.registerNode(PostProcessRopNode, CATEGORY_ROP.NETWORK);
    poly.registerNode(RenderersRopNode, CATEGORY_ROP.NETWORK);
  }
}
