import { AddSopNode } from '../../../nodes/sop/Add';
import { AnimationCopySopNode } from '../../../nodes/sop/AnimationCopy';
import { AnimationMixerSopNode } from '../../../nodes/sop/AnimationMixer';
import { AnimationsSopNode } from '../../../nodes/sop/Animations';
import { AttribAddMultSopNode } from '../../../nodes/sop/AttribAddMult';
import { AttribCopySopNode } from '../../../nodes/sop/AttribCopy';
import { AttribCreateSopNode } from '../../../nodes/sop/AttribCreate';
import { AttribDeleteSopNode } from '../../../nodes/sop/AttribDelete';
import { AttribFromTextureSopNode } from '../../../nodes/sop/AttribFromTexture';
import { AttribNormalizeSopNode } from '../../../nodes/sop/AttribNormalize';
import { AttribPromoteSopNode } from '../../../nodes/sop/AttribPromote';
import { AttribRemapSopNode } from '../../../nodes/sop/AttribRemap';
import { AttribRenameSopNode } from '../../../nodes/sop/AttribRename';
import { AttribTransferSopNode } from '../../../nodes/sop/AttribTransfer';
import { BboxScatterSopNode } from '../../../nodes/sop/BboxScatter';
import { BlendSopNode } from '../../../nodes/sop/Blend';
import { BoxSopNode } from '../../../nodes/sop/Box';
import { CacheSopNode } from '../../../nodes/sop/Cache';
import { CenterSopNode } from '../../../nodes/sop/Center';
import { CircleSopNode } from '../../../nodes/sop/Circle';
import { Circle3PointsSopNode } from '../../../nodes/sop/Circle3Points';
import { ColorSopNode } from '../../../nodes/sop/Color';
import { ConeSopNode } from '../../../nodes/sop/Cone';
import { CopSopNode } from '../../../nodes/sop/Cop';
import { CopySopNode } from '../../../nodes/sop/Copy';
import { Css2DObjectSopNode } from '../../../nodes/sop/Css2DObject';
import { Css3DObjectSopNode } from '../../../nodes/sop/Css3DObject';
import { DataSopNode } from '../../../nodes/sop/Data';
import { DataUrlSopNode } from '../../../nodes/sop/DataUrl';
import { DelaySopNode } from '../../../nodes/sop/Delay';
import { DeleteSopNode } from '../../../nodes/sop/Delete';
import { DrawRangeSopNode } from '../../../nodes/sop/DrawRange';
import { EventsSopNode } from '../../../nodes/sop/Events';
import { FaceSopNode } from '../../../nodes/sop/Face';
import { FileSopNode } from '../../../nodes/sop/File';
import { FuseSopNode } from '../../../nodes/sop/Fuse';
import { HexagonsSopNode } from '../../../nodes/sop/Hexagons';
import { HierarchySopNode } from '../../../nodes/sop/Hierarchy';
import { HeightMapSopNode } from '../../../nodes/sop/HeightMap';
import { IcosahedronSopNode } from '../../../nodes/sop/Icosahedron';
import { InstanceSopNode } from '../../../nodes/sop/Instance';
import { InstancesCountSopNode } from '../../../nodes/sop/InstancesCount';
import { JitterSopNode } from '../../../nodes/sop/Jitter';
import { JsPointSopNode } from '../../../nodes/sop/JsPoint';
import { LayerSopNode } from '../../../nodes/sop/Layer';
import { LineSopNode } from '../../../nodes/sop/Line';
import { LodSopNode } from '../../../nodes/sop/Lod';
import { MaterialSopNode } from '../../../nodes/sop/Material';
import { MaterialsSopNode } from '../../../nodes/sop/Materials';
import { MergeSopNode } from '../../../nodes/sop/Merge';
import { NoiseSopNode } from '../../../nodes/sop/Noise';
import { NormalsSopNode } from '../../../nodes/sop/Normals';
import { NullSopNode } from '../../../nodes/sop/Null';
import { ObjectMergeSopNode } from '../../../nodes/sop/ObjectMerge';
import { ObjectPropertiesSopNode } from '../../../nodes/sop/ObjectProperties';
import { OperationsComposerSopNode } from '../../../nodes/sop/OperationsComposer';
import { ParticlesSystemGpuSopNode } from '../../../nodes/sop/ParticlesSystemGpu';
import { PeakSopNode } from '../../../nodes/sop/Peak';
import { PlaneSopNode } from '../../../nodes/sop/Plane';
import { PointSopNode } from '../../../nodes/sop/Point';
import { PolySopNode } from '../../../nodes/sop/Poly';
import { PolywireSopNode } from '../../../nodes/sop/Polywire';
import { PostProcessSopNode } from '../../../nodes/sop/PostProcess';
import { RaySopNode } from '../../../nodes/sop/Ray';
import { RenderersSopNode } from '../../../nodes/sop/Renderers';
import { ResampleSopNode } from '../../../nodes/sop/Resample';
import { RestAttributesSopNode } from '../../../nodes/sop/RestAttributes';
import { RoundedBoxSopNode } from '../../../nodes/sop/RoundedBox';
import { ScatterSopNode } from '../../../nodes/sop/Scatter';
import { SkinSopNode } from '../../../nodes/sop/Skin';
import { SphereSopNode } from '../../../nodes/sop/Sphere';
import { SplitSopNode } from '../../../nodes/sop/Split';
import { SubdivideSopNode } from '../../../nodes/sop/Subdivide';
import { SubnetSopNode } from '../../../nodes/sop/Subnet';
import { SubnetInputSopNode } from '../../../nodes/sop/SubnetInput';
import { SubnetOutputSopNode } from '../../../nodes/sop/SubnetOutput';
import { SvgSopNode } from '../../../nodes/sop/Svg';
import { SwitchSopNode } from '../../../nodes/sop/Switch';
import { TetrahedronSopNode } from '../../../nodes/sop/Tetrahedron';
import { TextSopNode } from '../../../nodes/sop/Text';
import { TexturePropertiesSopNode } from '../../../nodes/sop/TextureProperties';
import { TorusSopNode } from '../../../nodes/sop/Torus';
import { TorusKnotSopNode } from '../../../nodes/sop/TorusKnot';
import { TransformSopNode } from '../../../nodes/sop/Transform';
import { TransformCopySopNode } from '../../../nodes/sop/TransformCopy';
import { TransformMultiSopNode } from '../../../nodes/sop/TransformMulti';
import { TransformResetSopNode } from '../../../nodes/sop/TransformReset';
import { TubeSopNode } from '../../../nodes/sop/Tube';
import { UvProjectSopNode } from '../../../nodes/sop/UvProject';
export interface GeoNodeChildrenMap {
    add: AddSopNode;
    animationCopy: AnimationCopySopNode;
    animationMixer: AnimationMixerSopNode;
    animations: AnimationsSopNode;
    attribAddMult: AttribAddMultSopNode;
    attribCopy: AttribCopySopNode;
    attribCreate: AttribCreateSopNode;
    attribDelete: AttribDeleteSopNode;
    attribFromTexture: AttribFromTextureSopNode;
    attribNormalize: AttribNormalizeSopNode;
    attribPromote: AttribPromoteSopNode;
    attribRemap: AttribRemapSopNode;
    attribRename: AttribRenameSopNode;
    attribTransfer: AttribTransferSopNode;
    bboxScatter: BboxScatterSopNode;
    blend: BlendSopNode;
    box: BoxSopNode;
    cache: CacheSopNode;
    center: CenterSopNode;
    circle: CircleSopNode;
    circle3Points: Circle3PointsSopNode;
    color: ColorSopNode;
    cone: ConeSopNode;
    cop: CopSopNode;
    copy: CopySopNode;
    css2DObject: Css2DObjectSopNode;
    css3DObject: Css3DObjectSopNode;
    data: DataSopNode;
    dataUrl: DataUrlSopNode;
    delay: DelaySopNode;
    delete: DeleteSopNode;
    drawRange: DrawRangeSopNode;
    events: EventsSopNode;
    face: FaceSopNode;
    file: FileSopNode;
    fuse: FuseSopNode;
    heightMap: HeightMapSopNode;
    hexagons: HexagonsSopNode;
    hierarchy: HierarchySopNode;
    icosahedron: IcosahedronSopNode;
    instance: InstanceSopNode;
    instancesCount: InstancesCountSopNode;
    jitter: JitterSopNode;
    jsPoint: JsPointSopNode;
    layer: LayerSopNode;
    line: LineSopNode;
    lod: LodSopNode;
    material: MaterialSopNode;
    materials: MaterialsSopNode;
    merge: MergeSopNode;
    postProcess: PostProcessSopNode;
    noise: NoiseSopNode;
    normals: NormalsSopNode;
    null: NullSopNode;
    objectMerge: ObjectMergeSopNode;
    objectProperties: ObjectPropertiesSopNode;
    operationsComposer: OperationsComposerSopNode;
    particlesSystemGpu: ParticlesSystemGpuSopNode;
    peak: PeakSopNode;
    plane: PlaneSopNode;
    point: PointSopNode;
    poly: PolySopNode;
    polywire: PolywireSopNode;
    ray: RaySopNode;
    renderers: RenderersSopNode;
    resample: ResampleSopNode;
    restAttributes: RestAttributesSopNode;
    roundedBox: RoundedBoxSopNode;
    scatter: ScatterSopNode;
    skin: SkinSopNode;
    sphere: SphereSopNode;
    split: SplitSopNode;
    subdivide: SubdivideSopNode;
    subnet: SubnetSopNode;
    subnetInput: SubnetInputSopNode;
    subnetOutput: SubnetOutputSopNode;
    svg: SvgSopNode;
    switch: SwitchSopNode;
    tetrahedron: TetrahedronSopNode;
    text: TextSopNode;
    textureProperties: TexturePropertiesSopNode;
    torus: TorusSopNode;
    torusKnot: TorusKnotSopNode;
    transform: TransformSopNode;
    transformCopy: TransformCopySopNode;
    transformMulti: TransformMultiSopNode;
    transformReset: TransformResetSopNode;
    tube: TubeSopNode;
    uvProject: UvProjectSopNode;
}
import { PolyEngine } from '../../../Poly';
export declare class SopRegister {
    static run(poly: PolyEngine): void;
}
